// ########################################################################
// ## randcubic.h:                                                       ##
// ## Klasse zur randomisierten Erzeugung kubischer Graphen              ##
// ## Copyright Thomas Dreibholz, uzs6pq@ibm.rhrz.uni-bonn.de            ##
// ##           WWW Homepage:     http://ibm.rhrz.uni-bonn.de/~uzs6pq    ##
// ########################################################################

#ifndef RANDCUBIC_H
#define RANDCUBIC_H


#include "../system.h"


// Klasse zur randomisierten Erzeugung kubischer Graphen
class RandCubic
{
   public:
   RandCubic(const card32 max);
   ~RandCubic();

   // Graphenerzeugungsfunktionen
   void Choose(const card32 n, const card32 k);
   void GraphA(const card32 n);
   void GraphB(const card32 n, card32& neg);
   void GraphB2(const card32 n, card32& neg);
   void GraphB3(const card32 n, card32& neg);
   void GraphC(const card32 n, card32& neg);
   void GraphC1(const card32 n, card32& neg);
   void GraphC2(const card32 n, card32& neg);
   void GraphC3(const card32 n, card32& neg);
   void GraphC4(const card32 n, card32& neg);
   void GraphC5(const card32 n, card32& neg);
   void GraphD(const card32 n);

   // Startfunktion
   void InitialisiereLabels(const card32 n);
   void Start();

   // Ausgabe-Operator
   friend ostream& operator << (ostream& os, const RandCubic& graph);
   void Schreibe(ostream& os, const bool bitMatrix,
                 const card32 typ = 0, const card32 neg = 0);
   
   private:
   card32  pos;
   card32  knoten;
   card32* labels;
   card32* edges;
};

#define A_GRAPH 1
#define B_GRAPH 2
#define C_GRAPH 3
#define D_GRAPH 4

#endif
